<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createModuleAccess StructType
 * @subpackage Structs
 */
class CreateModuleAccess extends AbstractStructBase
{
    /**
     * The ctx
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Context
     */
    public $ctx;
    /**
     * The admin_user
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\User
     */
    public $admin_user;
    /**
     * The access
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserModuleAccess
     */
    public $access;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * The schema_select_strategy
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SchemaSelectStrategy
     */
    public $schema_select_strategy;
    /**
     * Constructor method for createModuleAccess
     * @uses CreateModuleAccess::setCtx()
     * @uses CreateModuleAccess::setAdmin_user()
     * @uses CreateModuleAccess::setAccess()
     * @uses CreateModuleAccess::setAuth()
     * @uses CreateModuleAccess::setSchema_select_strategy()
     * @param \StructType\Context $ctx
     * @param \StructType\User $admin_user
     * @param \StructType\UserModuleAccess $access
     * @param \StructType\Credentials $auth
     * @param \StructType\SchemaSelectStrategy $schema_select_strategy
     */
    public function __construct(\StructType\Context $ctx = null, \StructType\User $admin_user = null, \StructType\UserModuleAccess $access = null, \StructType\Credentials $auth = null, \StructType\SchemaSelectStrategy $schema_select_strategy = null)
    {
        $this
            ->setCtx($ctx)
            ->setAdmin_user($admin_user)
            ->setAccess($access)
            ->setAuth($auth)
            ->setSchema_select_strategy($schema_select_strategy);
    }
    /**
     * Get ctx value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Context|null
     */
    public function getCtx()
    {
        return isset($this->ctx) ? $this->ctx : null;
    }
    /**
     * Set ctx value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Context $ctx
     * @return \StructType\CreateModuleAccess
     */
    public function setCtx(\StructType\Context $ctx = null)
    {
        if (is_null($ctx) || (is_array($ctx) && empty($ctx))) {
            unset($this->ctx);
        } else {
            $this->ctx = $ctx;
        }
        return $this;
    }
    /**
     * Get admin_user value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\User|null
     */
    public function getAdmin_user()
    {
        return isset($this->admin_user) ? $this->admin_user : null;
    }
    /**
     * Set admin_user value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\User $admin_user
     * @return \StructType\CreateModuleAccess
     */
    public function setAdmin_user(\StructType\User $admin_user = null)
    {
        if (is_null($admin_user) || (is_array($admin_user) && empty($admin_user))) {
            unset($this->admin_user);
        } else {
            $this->admin_user = $admin_user;
        }
        return $this;
    }
    /**
     * Get access value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserModuleAccess|null
     */
    public function getAccess()
    {
        return isset($this->access) ? $this->access : null;
    }
    /**
     * Set access value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserModuleAccess $access
     * @return \StructType\CreateModuleAccess
     */
    public function setAccess(\StructType\UserModuleAccess $access = null)
    {
        if (is_null($access) || (is_array($access) && empty($access))) {
            unset($this->access);
        } else {
            $this->access = $access;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\CreateModuleAccess
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Get schema_select_strategy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SchemaSelectStrategy|null
     */
    public function getSchema_select_strategy()
    {
        return isset($this->schema_select_strategy) ? $this->schema_select_strategy : null;
    }
    /**
     * Set schema_select_strategy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SchemaSelectStrategy $schema_select_strategy
     * @return \StructType\CreateModuleAccess
     */
    public function setSchema_select_strategy(\StructType\SchemaSelectStrategy $schema_select_strategy = null)
    {
        if (is_null($schema_select_strategy) || (is_array($schema_select_strategy) && empty($schema_select_strategy))) {
            unset($this->schema_select_strategy);
        } else {
            $this->schema_select_strategy = $schema_select_strategy;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateModuleAccess
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
